
// Spawning tool.
TOOL.Category		= "VMF-Suite";
TOOL.Name		= "Select";
TOOL.Command		= nil;
TOOL.ConfigName		= "";


// Add language.
if ( CLIENT ) then
	language.Add( "select_tool", "Select" );	// ???
	language.Add( "Tool_select_tool_name", "VMF-Suite Selector Tool" );
	language.Add( "Tool_select_tool_desc", "Generic VMF-Suite tool." );
	language.Add( "Tool_select_tool_0", "Left click to select an entity, Right click to deselect an entity." );
end

// Left click.
function TOOL:LeftClick( tr )
	// Don't allow the client to pass.
	if( CLIENT || SERVER ) then return true; end
	
	// didn't hit?
	if( !tr.HitNonWorld || !tr.Entity:IsValid() ) then return; end
	VMFSuite:addEntityToSelection( self:GetOwner(), tr.Entity );
	
	// process entity list.
	VMFSuite:wipePreview( self:GetOwner() );
	VMFSuite:doProcessEntityList( self:GetOwner() );

	return true;
end

// Right click.
function TOOL:RightClick( tr )
	// client be gone.. our newest product.
	if( CLIENT || SERVER ) then return true; end
	
	// didn't hit?
	if( !tr.HitNonWorld || !tr.Entity:IsValid() ) then return; end
	VMFSuite:removeEntityFromSelection( self:GetOwner(), tr.Entity );
	
	// process entity list.
	VMFSuite:wipePreview( self:GetOwner() );
	VMFSuite:doProcessEntityList( self:GetOwner() );
	
	return true;
end

// Holster.
function TOOL:Holster( )
	// client be gone.. our newest product.
	if( CLIENT || SERVER ) then return; end
	
	// wipe the preview away.
	VMFSuite:wipePreview( self:GetOwner() );
	
	// reset..
	self:GetOwner():GetTable().VMFSuite.ready_to_spawn = {};
end

// reload
function TOOL:Reload( trace )
	// Don't allow the client to pass.
	if( CLIENT || SERVER ) then return true; end
	
	// Spawn.
	VMFSuite:loadReadyToSpawn( self:GetOwner(), trace.HitPos, false );
	
	return true;
end


// deploy.
function TOOL:Deploy( )
	// client be gone.. our newest product.
	if( CLIENT || SERVER ) then return; end

	// do we have a selection?
	local pl = self:GetOwner();
	VMFSuite:validateSelection( pl );
	if( table.getn( pl:GetTable().VMFSuite.selection ) > 0 ) then
		// process list!
		VMFSuite:doProcessEntityList( pl );
	end
end



// Build context panel.
function TOOL.BuildCPanel( CPanel )
	// header
	CPanel:AddControl( "Header", { Text = "#Tool_select_tool_name", Description	= "#Tool_select_tool_desc" }  )
	
	// presets.
	local params = { Label = "#Presets", MenuButton = 1, Folder = "vmf-suite", Options = {}, CVars = {} };
	params.Options.default = { vmf_rotation = 3, vmf_height = 0.1 };
	table.insert( params.CVars, "vmf_rotation" );
	table.insert( params.CVars, "vmf_height" );
	CPanel:AddControl( "ComboBox", params );

	
	// rotation
	CPanel:AddControl( "Slider",  { Label	= "Rotation",
					Type	= "Float",
					Min		= 0.0,
					Max		= 360.0,
					Command = "vmf_rotation" } );
			
	// height.		
	CPanel:AddControl( "Slider",  { Label	= "Height",
					Type	= "Integer",
					Min		= 0,
					Max		= 1024,
					Command = "vmf_height" } );
end
